from google.cloud import bigquery
from time import sleep
import datetime
from threading import Thread, Event

import json

PROJECT = 'tfos-anomaly-detection'
DATASET = 'taxi_anomaly_detection_dataset'
TABLE = 'predictions'


def query(query_string):
    client = bigquery.Client(PROJECT)
    job = client.query(query_string)
    result = job.result()
    return result


class StreamingThread(Thread):
    def __init__(self, socketio):
        # TODO: Change to 3600 seconds (1 hour)
        self.delay_seconds = 120
        self.thread_stop_event = Event()
        self.socketio = socketio
        super(StreamingThread, self).__init__()

    def stream(self):
        while not self.thread_stop_event.isSet():
            last_hour_date_time = datetime.datetime.utcnow() - datetime.timedelta(hours=1)
            date_format = '%Y-%m-%d'
            hour = last_hour_date_time.hour
            date = last_hour_date_time.strftime(date_format)

            print("date = " + str(date))
            print("hour = " + str(hour))

            # query_string = """
            #     SELECT
            #       dropoff_date, dropoff_hour, dropoff_taxizone_id,
            #        pickup_date,  pickup_hour,  pickup_taxizone_id,
            #        anomaly_probability
            #     FROM `{0}.{1}.{2}`
            #     WHERE dropoff_date = '{3}' AND dropoff_hour = {4}
            #     ORDER BY pickup_date, pickup_hour DESC""".format(PROJECT, DATASET, TABLE, date, hour)

            # Mock query, extracts last 100 records:
            query_string = """
                SELECT
                  dropoff_date, dropoff_hour, dropoff_taxizone_id,
                   pickup_date,  pickup_hour,  pickup_taxizone_id,
                   anomaly_probability
                FROM `{0}.{1}.{2}`
                ORDER BY pickup_date, pickup_hour DESC
                LIMIT 100""".format(PROJECT, DATASET, TABLE)

            result = query(query_string)

            result_pd = result.to_dataframe()
            result_json = result_pd.to_json()

            # Mock data:

            # result_json = '{"dropoff_date":{"0":1526515200000,"1":1526515200000,"2":1526515200000,"3":1526515200000,' \
            #               '"4":1526515200000,"5":1526515200000,"6":1526515200000,"7":1526515200000,"8":1526515200000,' \
            #               '"9":1526515200000,"10":1526515200000,"11":1526515200000,"12":1526515200000,' \
            #               '"13":1526515200000,"14":1526515200000,"15":1526515200000,"16":1526515200000,' \
            #               '"17":1526515200000,"18":1526515200000,"19":1526515200000,"20":1526515200000,' \
            #               '"21":1526515200000,"22":1526515200000,"23":1526515200000,"24":1526515200000,' \
            #               '"25":1526515200000,"26":1526515200000,"27":1526515200000,"28":1526515200000,' \
            #               '"29":1526515200000,"30":1526515200000,"31":1526515200000,"32":1526515200000,' \
            #               '"33":1526515200000,"34":1526515200000,"35":1526515200000,"36":1526515200000,' \
            #               '"37":1526515200000,"38":1526515200000,"39":1526515200000,"40":1526515200000,' \
            #               '"41":1526515200000,"42":1526515200000,"43":1526515200000,"44":1526515200000,' \
            #               '"45":1526515200000,"46":1526515200000,"47":1526515200000,"48":1526515200000,' \
            #               '"49":1526515200000,"50":1526515200000,"51":1526515200000,"52":1526515200000,' \
            #               '"53":1526515200000,"54":1526515200000,"55":1526515200000,"56":1526515200000,' \
            #               '"57":1526515200000,"58":1526515200000,"59":1526515200000,"60":1526515200000,' \
            #               '"61":1526515200000,"62":1526515200000,"63":1526515200000,"64":1526515200000,' \
            #               '"65":1526515200000,"66":1526515200000,"67":1526515200000,"68":1526515200000,' \
            #               '"69":1526515200000,"70":1526515200000,"71":1526515200000,"72":1526515200000,' \
            #               '"73":1526515200000,"74":1526515200000,"75":1526515200000,"76":1526515200000,' \
            #               '"77":1526515200000,"78":1526515200000,"79":1526515200000,"80":1526515200000,' \
            #               '"81":1526515200000,"82":1526515200000,"83":1526515200000,"84":1526515200000,' \
            #               '"85":1526515200000,"86":1526515200000,"87":1526515200000,"88":1526515200000,' \
            #               '"89":1526515200000,"90":1526515200000,"91":1526515200000,"92":1526515200000,' \
            #               '"93":1526515200000,"94":1526515200000,"95":1526515200000,"96":1526515200000,' \
            #               '"97":1526515200000,"98":1526515200000,"99":1526515200000},"dropoff_hour":{"0":14,"1":14,' \
            #               '"2":14,"3":14,"4":14,"5":14,"6":14,"7":14,"8":14,"9":14,"10":14,"11":14,"12":14,"13":14,' \
            #               '"14":14,"15":14,"16":14,"17":14,"18":14,"19":14,"20":14,"21":14,"22":14,"23":14,"24":14,' \
            #               '"25":14,"26":14,"27":14,"28":14,"29":14,"30":14,"31":14,"32":14,"33":14,"34":14,"35":14,' \
            #               '"36":14,"37":14,"38":14,"39":14,"40":14,"41":14,"42":14,"43":14,"44":14,"45":14,"46":14,' \
            #               '"47":14,"48":14,"49":14,"50":14,"51":14,"52":14,"53":14,"54":14,"55":14,"56":14,"57":14,' \
            #               '"58":14,"59":14,"60":14,"61":14,"62":14,"63":14,"64":14,"65":14,"66":14,"67":14,"68":14,' \
            #               '"69":14,"70":14,"71":14,"72":14,"73":14,"74":14,"75":14,"76":14,"77":14,"78":14,"79":14,' \
            #               '"80":14,"81":14,"82":14,"83":14,"84":14,"85":14,"86":14,"87":14,"88":14,"89":14,"90":14,' \
            #               '"91":14,"92":14,"93":14,"94":14,"95":14,"96":14,"97":14,"98":14,"99":14},' \
            #               '"dropoff_taxizone_id":{"0":166,"1":232,"2":88,"3":86,"4":248,"5":54,"6":226,"7":166,"8":6,' \
            #               '"9":75,"10":179,"11":83,"12":65,"13":47,"14":103,"15":198,"16":36,"17":180,"18":256,' \
            #               '"19":65,"20":87,"21":4,"22":59,"23":80,"24":115,"25":97,"26":201,"27":121,"28":125,' \
            #               '"29":80,"30":45,"31":12,"32":132,"33":192,"34":33,"35":235,"36":126,"37":36,"38":86,' \
            #               '"39":242,"40":166,"41":126,"42":242,"43":217,"44":125,"45":33,"46":115,"47":151,"48":232,' \
            #               '"49":111,"50":255,"51":115,"52":82,"53":242,"54":132,"55":243,"56":166,"57":135,"58":189,' \
            #               '"59":41,"60":189,"61":97,"62":151,"63":12,"64":27,"65":232,"66":120,"67":226,"68":87,' \
            #               '"69":172,"70":71,"71":121,"72":75,"73":208,"74":256,"75":76,"76":87,"77":223,"78":41,' \
            #               '"79":189,"80":129,"81":47,"82":226,"83":88,"84":116,"85":65,"86":7,"87":217,"88":17,' \
            #               '"89":235,"90":111,"91":132,"92":52,"93":168,"94":223,"95":166,"96":36,"97":47,"98":27,' \
            #               '"99":155},"pickup_date":{"0":1526515200000,"1":1526515200000,"2":1526515200000,' \
            #               '"3":1526515200000,"4":1526515200000,"5":1526515200000,"6":1526515200000,"7":1526515200000,' \
            #               '"8":1526515200000,"9":1526515200000,"10":1526515200000,"11":1526515200000,' \
            #               '"12":1526515200000,"13":1526515200000,"14":1526515200000,"15":1526515200000,' \
            #               '"16":1526515200000,"17":1526515200000,"18":1526515200000,"19":1526515200000,' \
            #               '"20":1526515200000,"21":1526515200000,"22":1526515200000,"23":1526515200000,' \
            #               '"24":1526515200000,"25":1526515200000,"26":1526515200000,"27":1526515200000,' \
            #               '"28":1526515200000,"29":1526515200000,"30":1526515200000,"31":1526515200000,' \
            #               '"32":1526515200000,"33":1526515200000,"34":1526515200000,"35":1526515200000,' \
            #               '"36":1526515200000,"37":1526515200000,"38":1526515200000,"39":1526515200000,' \
            #               '"40":1526515200000,"41":1526515200000,"42":1526515200000,"43":1526515200000,' \
            #               '"44":1526515200000,"45":1526515200000,"46":1526515200000,"47":1526515200000,' \
            #               '"48":1526515200000,"49":1526515200000,"50":1526515200000,"51":1526515200000,' \
            #               '"52":1526515200000,"53":1526515200000,"54":1526515200000,"55":1526515200000,' \
            #               '"56":1526515200000,"57":1526515200000,"58":1526515200000,"59":1526515200000,' \
            #               '"60":1526515200000,"61":1526515200000,"62":1526515200000,"63":1526515200000,' \
            #               '"64":1526515200000,"65":1526515200000,"66":1526515200000,"67":1526515200000,' \
            #               '"68":1526515200000,"69":1526515200000,"70":1526515200000,"71":1526515200000,' \
            #               '"72":1526515200000,"73":1526515200000,"74":1526515200000,"75":1526515200000,' \
            #               '"76":1526515200000,"77":1526515200000,"78":1526515200000,"79":1526515200000,' \
            #               '"80":1526515200000,"81":1526515200000,"82":1526515200000,"83":1526515200000,' \
            #               '"84":1526515200000,"85":1526515200000,"86":1526515200000,"87":1526515200000,' \
            #               '"88":1526515200000,"89":1526515200000,"90":1526515200000,"91":1526515200000,' \
            #               '"92":1526515200000,"93":1526515200000,"94":1526515200000,"95":1526515200000,' \
            #               '"96":1526515200000,"97":1526515200000,"98":1526515200000,"99":1526515200000},' \
            #               '"pickup_hour":{"0":14,"1":14,"2":14,"3":14,"4":14,"5":14,"6":14,"7":14,"8":14,"9":14,' \
            #               '"10":14,"11":14,"12":14,"13":14,"14":14,"15":14,"16":14,"17":14,"18":14,"19":14,"20":14,' \
            #               '"21":14,"22":14,"23":14,"24":14,"25":14,"26":14,"27":14,"28":14,"29":14,"30":14,"31":14,' \
            #               '"32":14,"33":14,"34":14,"35":14,"36":14,"37":14,"38":14,"39":14,"40":14,"41":14,"42":14,' \
            #               '"43":14,"44":14,"45":14,"46":14,"47":14,"48":14,"49":14,"50":14,"51":14,"52":14,"53":14,' \
            #               '"54":14,"55":14,"56":14,"57":14,"58":14,"59":14,"60":14,"61":14,"62":14,"63":14,"64":14,' \
            #               '"65":14,"66":14,"67":14,"68":14,"69":14,"70":14,"71":14,"72":14,"73":14,"74":14,"75":14,' \
            #               '"76":14,"77":14,"78":14,"79":14,"80":14,"81":14,"82":14,"83":14,"84":14,"85":14,"86":14,' \
            #               '"87":14,"88":14,"89":14,"90":14,"91":14,"92":14,"93":14,"94":14,"95":14,"96":14,"97":14,' \
            #               '"98":14,"99":14},"pickup_taxizone_id":{"0":263,"1":42,"2":131,"3":83,"4":49,"5":90,"6":40,' \
            #               '"7":136,"8":48,"9":138,"10":78,"11":63,"12":133,"13":261,"14":133,"15":265,"16":106,' \
            #               '"17":41,"18":138,"19":47,"20":138,"21":48,"22":138,"23":49,"24":137,"25":78,"26":74,' \
            #               '"27":141,"28":79,"29":139,"30":262,"31":90,"32":262,"33":133,"34":262,"35":97,"36":25,' \
            #               '"37":138,"38":40,"39":107,"40":43,"41":139,"42":43,"43":133,"44":47,"45":138,"46":48,' \
            #               '"47":138,"48":49,"49":138,"50":49,"51":137,"52":51,"53":137,"54":68,"55":136,"56":78,' \
            #               '"57":72,"58":142,"59":78,"60":113,"61":79,"62":133,"63":79,"64":74,"65":87,"66":87,' \
            #               '"67":87,"68":133,"69":90,"70":90,"71":90,"72":42,"73":90,"74":97,"75":97,"76":139,' \
            #               '"77":100,"78":100,"79":103,"80":139,"81":107,"82":107,"83":107,"84":138,"85":125,"86":107,' \
            #               '"87":129,"88":263,"89":131,"90":132,"91":132,"92":138,"93":3,"94":261,"95":138,"96":137,' \
            #               '"97":137,"98":133,"99":78},"anomaly_probability":{"0":0.073269635,"1":0.3797418,' \
            #               '"2":0.09828749,"3":0.004474193,"4":0.14371169,"5":0.027043551,"6":0.017589211,' \
            #               '"7":0.6988318,"8":0.004336238,"9":0.004653096,"10":0.020505577,"11":0.0035826266,' \
            #               '"12":0.019078463,"13":0.17085287,"14":0.4197912,"15":0.12541625,"16":0.015920967,' \
            #               '"17":0.0027906597,"18":0.005965501,"19":0.6276853,"20":0.004104048,"21":0.0072839856,' \
            #               '"22":0.100611985,"23":0.014627606,"24":0.008385211,"25":0.004278928,"26":0.0032134652,' \
            #               '"27":0.00826326,"28":0.08959633,"29":0.0021880567,"30":0.005243808,"31":0.0024579763,' \
            #               '"32":0.0037533045,"33":0.016743422,"34":0.003733188,"35":0.0027084053,"36":0.02136013,' \
            #               '"37":0.0019029379,"38":0.34333697,"39":0.0064860284,"40":0.006114632,"41":0.003754735,' \
            #               '"42":0.015812606,"43":0.20749319,"44":0.0024363399,"45":0.018847793,"46":0.0013997555,' \
            #               '"47":0.0016190708,"48":0.030923188,"49":0.031731874,"50":0.033014417,"51":0.0013235807,' \
            #               '"52":0.022423357,"53":0.5305065,"54":0.0658443,"55":0.037584186,"56":0.008546323,' \
            #               '"57":0.014421523,"58":0.01720503,"59":0.010285199,"60":0.13587606,"61":0.003909856,' \
            #               '"62":0.07352811,"63":0.033910632,"64":0.0028238297,"65":0.05904892,"66":0.010321498,' \
            #               '"67":0.035802305,"68":0.060937107,"69":0.027850628,"70":0.014609635,"71":0.23765177,' \
            #               '"72":0.0058677793,"73":0.0021732152,"74":0.059585452,"75":0.04063806,"76":0.004202485,' \
            #               '"77":0.028611302,"78":0.13501427,"79":0.10087001,"80":0.0016747713,"81":0.09663856,' \
            #               '"82":0.007416934,"83":0.018739164,"84":0.0071363747,"85":0.007006377,"86":0.01221022,' \
            #               '"87":0.0035320222,"88":0.01024577,"89":0.48913926,"90":0.0039690435,"91":0.011815131,' \
            #               '"92":0.009220809,"93":0.08379865,"94":0.016844898,"95":0.02451852,"96":0.014424026,' \
            #               '"97":0.029847354,"98":0.06202054,"99":0.0051681697}} '

            print(result_json)
            self.socketio.emit('newdata', result_json, namespace='/test')
            sleep(self.delay_seconds)

    def run(self):
        self.stream()

    def stop(self):
        self.thread_stop_event.set()

    def stopped(self):
        return self.thread_stop_event.is_set()


def get_taxizones():
    query_string = """
        SELECT dropoff_taxizone_id
        FROM `{0}.{1}.{2}`
        GROUP BY dropoff_taxizone_id
        ORDER BY dropoff_taxizone_id ASC""".format(PROJECT, DATASET, TABLE)

    result = query(query_string)
    result_list = list()

    for row in result:
        result_list.append(row.dropoff_taxizone_id)

    result_json = json.dumps(result_list)
    return result_json


def get_anomalies_per_hour(pickup_taxizone_id, dropoff_taxizone_id, date):
    query_string = """
        SELECT dropoff_hour, AVG(anomaly_probability) as anomaly_probability
        FROM `{0}.{1}.{2}`
        WHERE pickup_taxizone_id = {3} AND dropoff_taxizone_id = {4} AND dropoff_date = '{5}'
        GROUP BY dropoff_hour
        ORDER BY dropoff_hour ASC""".format(
        PROJECT, DATASET, TABLE,
        pickup_taxizone_id, dropoff_taxizone_id, date)

    result = query(query_string)

    hours_list = list()
    anomalies_list = list()

    if result is not None:
        for row in result:
            hours_list.append(row.dropoff_hour)
            anomalies_list.append(row.anomaly_probability)

    return hours_list, anomalies_list


def get_min_date():
    query_string = """
        SELECT MIN(dropoff_date) as min_date
        FROM `{0}.{1}.{2}`""".format(PROJECT, DATASET, TABLE)

    result = query(query_string)

    min_date = datetime.datetime.utcnow()
    for row in result:
        min_date = row.min_date
    return min_date


def generate_date_range(min_date):
    dates = list()

    start = datetime.datetime(min_date.year, min_date.month, min_date.day)
    end = datetime.datetime.utcnow()
    step = datetime.timedelta(hours=1)
    while start <= end:
        date = str(start.date()) + " " + str(start.hour)
        dates.append(date)
        start += step
    return dates


def get_predicted_results():
    min_date = get_min_date()
    date_range = generate_date_range(min_date)

    query_string = """
        SELECT dropoff_taxizone_id, dropoff_date, dropoff_hour, 
                AVG(anomaly_probability) as anomaly_probability
        FROM `{0}.{1}.{2}`
        GROUP BY dropoff_date, dropoff_hour, dropoff_taxizone_id
        ORDER BY dropoff_date, dropoff_hour""".format(PROJECT, DATASET, TABLE)

    result = query(query_string)
    dataset = dict()
    dates_len = len(date_range)

    for row in result:
        label = str(row.dropoff_taxizone_id)
        if label not in dataset:
            dataset[label] = [0.0] * dates_len
        date = str(row.dropoff_date) + " " + str(row.dropoff_hour)
        index = date_range.index(date)
        dataset[label][index] = row.anomaly_probability

    return date_range, dataset


def get_mock_predicted_results():
    hours_mock = list()
    anomalies_mock = list()
    import random
    for i in range(24):
        hours_mock.append(i)
        anomalies_mock.append(float(random.randint(0, 100)) / 100.0)
    hours, anomalies = hours_mock, anomalies_mock
    print(hours, anomalies)
    return hours, anomalies
